package _PonCmn;

#--------------------------------------------------------------------------
#
# _PonCmn.pm, (C)Copyright 2003 OGATA, Tetsuji
#
# PerlModule͏N쐬܂B
# 쌠͏Nɑ܂B
# 쌠폜ȂAgpEĔzz͂ȂړIłĂARɍs
# Ă܂܂B
# gpEĔzz̍ۂɉςKvȏꍇ́Aωӏmɂ킩悤ɂAł
# t@C(W[)ύXĂB
#
# CGIۂ  http://specters.net/cgipon/  N  cgipon@specters.net
#
#--------------------------------------------------------------------------

my $VERSION = '0.1.2';	# last modified 2003/06/13
require './jcode.pl';

#==========================================================================
#	[ API ]
#==========================================================================
#	print_http_header( COOKIE, GZIP )
#	get_cookie( NAME )
#	set_cookie( NAME, HASH )
#	parse_query( HASH )
#	get_date( FORMAT, TIME, LANG, TZ )
#	load_log( FILE, UNIT, PAGE, SEARCH, ARG, FIRST )
#	lock_file( FILE )
#	unlock_file( FILE )
#	save_hash( FILE, HASH )
#	load_hash( FILE, HASH )
#	input2log( STRING, NL, EMOJI )
#	log2output( STRING, LINK, FORM, EMOJI )
#	set2output( STRING, FORM )
#	divide_string( STRING, LENGTH, NUM )
#	send_mail( PATH, FROM, TO, SUBJECT, BODY )
#	get_random_string( NUM )
#	url_enc( STRING )
#	url_dec( STRING )
#	check_mail( STRING )
#	check_url( STRING )
#==========================================================================

#--------------------------------------------------------------------------
my $NL = '&br;';
my $CRLF = "\n";

#--------------------------------------------------------------------------
my $ASCII   = qr/(?:[\x00-\x7F])/;
my $SJIS_H  = qr/(?:[\x81-\x9F\xE0-\xFC])/;
my $SJIS_L  = qr/(?:[\x40-\x7E\x80-\xFC])/;
my $HANKANA = qr/(?:[\xA1-\xDF])/;

my $IEMOJI_H    = qr/(?:[\xF8\xF9])/;
my $DEMOJI_H    = qr/(?:[\xF0-\xF4])/;
my $AEMOJI_H    = qr/(?:[\xF0])/;
my $SJISEMOJI_H = qr/(?:[\xF0-\xF4\xF8\xF9])/;

my $JEMOJI_ESC = qr/(?:\e\$)/;
my $JEMOJI_SI  = qr/(?:\x0F|$)/;
my $JEMOJI_GEF = qr/(?:[GEF][\x21-\x7A]+)/;
my $JEMOJI_O   = qr/(?:O[\x21-\x6D]+)/;
my $JEMOJI_P   = qr/(?:P[\x21-\x6C]+)/;
my $JEMOJI_Q   = qr/(?:Q[\x21-\x69]+)/;
my $JEMOJI_INT = qr/(?:$JEMOJI_GEF|$JEMOJI_O|$JEMOJI_P|$JEMOJI_Q)/;

my $SJIS      = qr/(?:$SJIS_H$SJIS_L|$ASCII|$HANKANA)/;
my $IEMOJI    = qr/(?:$IEMOJI_H$SJIS_L)/;
my $DEMOJI    = qr/(?:$DEMOJI_H$SJIS_L)/;
my $AEMOJI    = qr/(?:$AEMOJI_H$SJIS_L)/;
my $SJISEMOJI = qr/(?:$SJISEMOJI_H$SJIS_L)/;
my $JEMOJI    = qr/(?:$JEMOJI_ESC$JEMOJI_INT$JEMOJI_SI)/;
my $HEMOJI    = qr/(?:&lt;#[A-Z\!]+&gt;)/;

my $NUM_IEMOJI    = qr/(?:63[5-9]\d\d)/; # 63552 - 63996
my $NUM_DEMOJI    = qr/(?:6[12]\d\d\d)/; # 61504 - 62716
my $NUM_AEMOJI    = qr/(?:61[56]\d\d)/;  # 61504 - 61689
my $NUM_SJISEMOJI = qr/(?:6\d{4})/;      # 61504 - 63996

#--------------------------------------------------------------------------
#	֐	print_http_header
#	@\	HTTPwb_̏o
#		COOKIE:	NbL[̕i[ϐ̃t@X
#			GZIP:	gzip̃pX
#			FILE:	XVt@C
#--------------------------------------------------------------------------
sub print_http_header
{
	my %param = (
		COOKIE => \'',
		GZIP => '',
		FILE => '',
		@_,
		);

	$| = 1;
	print qq(Content-type: text/html$CRLF);
	if ( $param{FILE} ) {
		my @mt = split(/\s+/, gmtime((stat($param{FILE}))[9]));
		print qq(Last-Modified: $mt[0], $mt[2] $mt[1] $mt[4] $mt[3] GMT$CRLF);
	}
	${$param{COOKIE}} and print qq(Set-Cookie: ${$param{COOKIE}}$CRLF);
	if ( $param{GZIP} && $ENV{HTTP_ACCEPT_ENCODING} =~ /gzip/ ) {
		if($ENV{HTTP_ACCEPT_ENCODING} =~ /x-gzip/ ) {
			print qq(Content-encoding: x-gzip$CRLF);
		}else{
			print qq(Content-encoding: gzip$CRLF);
		}
		print $CRLF;
		open(STDOUT, "| $param{GZIP} -1 -c");
	} else {
		print $CRLF;
	}
}

#==========================================================================
#	[ Cookie֘Ȁ ]
#==========================================================================
#--------------------------------------------------------------------------
#	֐	get_cookie
#	@\	NCAg󂯎NbL[f[^̉
#		NAME:	NbL[̖O
#	Ԓl	NbL[̃f[^i[nbṼt@X
#--------------------------------------------------------------------------
sub get_cookie
{
	my %param = (
		NAME => '',
		@_,
		);
	my $cookie;
	my %cookie;

	foreach ( split(/;/, $ENV{HTTP_COOKIE}) ) {
		my($name, $value) = split(/=/);
		$name =~ s/^\s*//;
		if ($name eq $param{NAME}) {
			$cookie = $value;
			last;
		}
	}

	foreach ( split(/<>/, $cookie) ) {
		my($name, $value) = split(/:/);
		&_url_dec(\$value);
		$cookie{$name} = $value;
	}

	return \%cookie;
}

#--------------------------------------------------------------------------
#	֐	set_cookie
#	@\	NCAgɓnNbL[f[^AĕԂ
#		NAME:	NbL[̖O
#			HASH:	NbL[̃f[^i[ꂽnbṼt@X
#	Ԓl	Set-Cookie̕
#--------------------------------------------------------------------------
sub set_cookie
{
	my %param = (
		NAME => '',		# Ȃ񂩌߂悤B
		HASH => {},
		@_,
		);

	my @cookie;
	my $cookie;
	my $expires;

	foreach ( keys(%{$param{HASH}}) ) {
		&_url_enc(\$param{HASH}->{$_});
		push(@cookie, "$_:$param{HASH}->{$_}");
	}
	$cookie = join('<>', @cookie);

	$expires = &get_date(
		FORMAT => 'DDD, dd-MM-yyyy HH:mm:ss',
		TIME => time() + 30 * 24 * 60 * 60,
		LANG => 'en',
		);
	return "$param{NAME}=$cookie; expires=$expires GMT";
}

#==========================================================================
#	[ Query֘Ȁ ]
#==========================================================================
#--------------------------------------------------------------------------
#	֐	parse_query
#	@\	POST܂GETŎ󂯎f[^nbVɏ㏑
#		HASH:	nbṼt@X
#--------------------------------------------------------------------------
sub parse_query
{
	my %param = (
		HASH => {},
		@_,
		);

	my $in;
	read(STDIN, $in, $ENV{CONTENT_LENGTH});
	$in = join('&', $in, $ENV{QUERY_STRING});

	foreach ( split(/&/, $in) ) {
		my($name, $value) = split(/=/, $_, 2);
		&_url_dec(\$value);
		&_crlf2nl(\$value);
		$param{HASH}->{$name} = $value;
	}
}

#==========================================================================
#	[ Ԋ֘Ȁ ]
#==========================================================================
#--------------------------------------------------------------------------
#	֐	get_date
#	@\	tƎԂ̕쐬
#		FORMAT:	̃tH[}bg
#			TIME:	
#			LANG:	
#				en:	p
#				ja:	{
#			TZ:		^C][
#	Ԓl	tƎԂ̕
#--------------------------------------------------------------------------
sub get_date
{
	my %param = (
		FORMAT => 'yyyy/MM/dd HH:mm',
		TIME => '',
		LANG => 'ja',
		TZ => 9,
		@_,
		);

	$ENV{TZ} = 'JST-' . $param{TZ};
	$param{TIME} ||= time();

	my($s, $m, $H, $d, $M, $yyyy, $DDD) = localtime($param{TIME});
	my($ss, $mm, $HH, $h, $hh, $dd, $MM, $yy, $t);
	$yyyy += 1900;
	$H < 12 ? $t = 0 : $t = 1;
	if ( $param{LANG} eq 'en' ) {
		$DDD = ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat')[$DDD];
		$M = ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
			'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec')[$M];
		$param{FORMAT} =~ s/MM/M/g;
		$t  = ('a.m.','p.m.')[$t];
	} else {
		$DDD = ('', '', '', '', '', '', 'y')[$DDD];
		$M++;
		$MM = sprintf("%02d", $M);
		$t = ('ߑO', 'ߌ')[$t];
	}
	$h = $H % 12;

	$yy = substr($yyyy, 2);
	$dd = sprintf("%02d", $d);
	$HH = sprintf("%02d", $H);
	$hh = sprintf("%02d", $h);
	$mm = sprintf("%02d", $m);
	$ss = sprintf("%02d", $s);

	$param{FORMAT} =~ s/yyyy/$yyyy/g;
	$param{FORMAT} =~ s/yy/$yy/g;
	$param{FORMAT} =~ s/HH/$HH/g;
	$param{FORMAT} =~ s/H/$H/g;
	$param{FORMAT} =~ s/hh/$hh/g;
	$param{FORMAT} =~ s/h/$h/g;
	$param{FORMAT} =~ s/mm/$mm/g;
	$param{FORMAT} =~ s/m/$m/g;
	$param{FORMAT} =~ s/ss/$ss/g;
	$param{FORMAT} =~ s/s/$s/g;
	$param{FORMAT} =~ s/t/$t/g;
	$param{FORMAT} =~ s/MM/$MM/g;
	$param{FORMAT} =~ s/M/$M/g;
	$param{FORMAT} =~ s/dd/$dd/g;
	$param{FORMAT} =~ s/d/$d/g;
	$param{FORMAT} =~ s/DDD/$DDD/g;

	return $param{FORMAT};
}


#==========================================================================
#	[ Log֘Ȁ ]
#==========================================================================
#--------------------------------------------------------------------------
#	֐	load_log
#	@\	Ot@C̍sPʂ̓ǂݍ
#		FILE:	t@C
#			UNIT:	ǂݍݒP(̏ꍇ̓t@CŜǂݍ)
#			PAGE:	ǂݍ݃y[Wԍ
#			SEARCH:	ǂݍݏ֐ւ̃t@X
#			ARG:	ǂݍݏ֐ɓnnbṼt@X
#			FIRST:	sڂ̂Ă邩ǂ
#				^l:	̂Ă
#				Ul;	̂ĂȂ
#	Ԓl	($err, $log, $page, $max)
#			$err:	G[R[h
#				0:	I
#				1:	G
#				2:	I[vs
#			$log:	ǂݏos̔z̃t@X
#			$page:	ۂ̃y[Wԍ
#			$num:	Ɉvs̑
#			$pmax:	y[Wԍ̍ől
#--------------------------------------------------------------------------
sub load_log
{
	my %param = (
		FILE => '',
		UNIT => 1,
		PAGE => '',
		SEARCH => sub { return 1; },
		ARG => {},
		FIRST => 0,
		@_,
		);

	my(@log, $page, $pmax, $num);

	&lock_file( FILE => $param{FILE} ) or return (1, \@log, $pmax, $num);
	open( FH, "<$param{FILE}" )
		or open( FH, ">$param{FILE}" )
		or return (2, \@log, $pmax);
	$param{FIRST} and <FH>;
	$page = 1;
	while ( my $line = <FH> ) {
		chomp $line;
		if ( &{$param{SEARCH}}( LINE => $line, %{$param{ARG}} ) ) {
			$num++;
			if ( $param{UNIT} < 0 || @log < $param{UNIT} ) {
				push(@log, $line);
			} elsif ( $page < $param{PAGE} ) {
				@log = ($line);
				$page++;
			}
		}
	}
	$pmax = int(($num - 1) / $param{UNIT}) + 1;

	close(FH);
	&unlock_file( FILE => $param{FILE} );

	return (0, \@log, $page, $num, $pmax);
}

#--------------------------------------------------------------------------
#	֐	lock_file
#	@\	w肳ꂽt@CbN
#		FILE:	t@C
#	Ԓl	^l:	
#			Ul:	s
#	⑫	̊֐ŃbNꂽt@CɂĂ̂ݔrs܂
#--------------------------------------------------------------------------
sub lock_file
{
	my %param = (
		FILE => '',
		@_,
		);

	my($lockdir1, $lockdir2);
	$lockdir1 = $param{FILE} . '1.dir';
	$lockdir2 = $param{FILE} . '2.dir';
	my $retry = 5;
	while ( !mkdir($lockdir1, 0755) ) {
		while ( $retry-- ) {
			if ( mkdir($lockdir2, 0755) ) {
				if ( (stat($lockdir1))[9] - time() > 120 ) {
					rename($lockdir2, $lockdir1);
					return 1;
				} else {
					rmdir($lockdir2);
				}
			}
			return 0;
		}
		sleep(1);
	}
	return 1;
}

#--------------------------------------------------------------------------
#	֐	unlock_file
#	@\	w肳ꂽt@C̃bN
#		FILE:	t@C
#	Ԓl	Ȃ
#--------------------------------------------------------------------------
sub unlock_file
{
	my %param = (
		FILE => '',
		@_,
		);

	rmdir($param{FILE} . '1.dir');
}

#--------------------------------------------------------------------------
#	֐	save_hash
#	@\	w肳ꂽt@CɃnbV̓eۑ
#		FILE:	t@C
#			HASH:	ۑnbṼt@X
#	Ԓl	G[R[h
#				0:	I
#				1:	G
#				2:	I[vs
#	⑫	nbV̒lt@X̏ꍇɂ͑ΉĂ܂
#--------------------------------------------------------------------------
sub save_hash
{
	my %param = (
		FILE => '',
		HASH => {},
		@_,
		);

	&lock_file( FILE => $param{FILE} ) or return ( 1 );
	open( FH, ">$param{FILE}" ) or return ( 2 );
	while ( my($name, $value) = each(%{$param{HASH}}) ) {
		&_enc_entity(\$name, 'nl');
		&_enc_entity(\$value, 'nl');
		print FH qq($name<>$value\n);
	}
	close(FH);
	&unlock_file( FILE => $param{FILE} );
}

#--------------------------------------------------------------------------
#	֐	load_hash
#	@\	w肳ꂽt@CnbV̓eǂݍ
#		FILE:	t@C
#			HASH:	ǂݍރnbṼt@X
#	Ԓl	G[R[h
#				0:	I
#				1:	G
#				2:	I[vs
#	⑫	nbV̒lt@X̏ꍇɂ͑ΉĂ܂
#--------------------------------------------------------------------------
sub load_hash
{
	my %param = (
		FILE => '',
		HASH => {},
		@_,
		);

	&lock_file( FILE => $param{FILE} ) or return 1;
	open( FH, "<$param{FILE}" )
		or open( FH, ">$param{FILE}" )
		or return 2;
	while ( my $line = <FH> ) {
		chomp $line;
		my($name, $value) = split(/<>/, $line);
		&_dec_entity(\$name, 'nl');
		&_dec_entity(\$value, 'nl');
		$param{HASH}->{$name} = $value;
	}
	close(FH);
	&unlock_file( FILE => $param{FILE} );
	return 0;
}

#--------------------------------------------------------------------------
#	֐F	input2log
#	F	CGI󂯎LOGt@Cɕۑ`ɕϊ܂B
#	F	STRING:	̃t@X
#			NL:		s̈
#				^l:	sLɂ(ftHg)
#				Ul:	s𖳌ɂ
#			EMOJI:	G̈
#				-1:	G𖳌ɂ
#				0:	Gɑ΂ĉȂ(ftHg)
#				1:	G10iR[h\Lɕϊ(J-SKYG͂̂܂)
#--------------------------------------------------------------------------
sub input2log
{
	my %param = (
		STRING => \'',
		NL => 1,
		EMOJI => 0,
		@_,
		);

	# ^uXy[Xɕϊ
	&_tab2space($param{STRING});

	if ( $param{NL} ) {
		# ʂȉs
		&_trim_line($param{STRING});
	} else {
		# s
		${$param{STRING}} =~ s/\n//g;
		# ʂȋ󔒂
		&_trim_char($param{STRING});
	}

	# <>&\n  &lt; &gt; &amp; &br; ɕϊ
	&_enc_entity($param{STRING}, 'nl');

	# Gǂɂ
	if ( $param{EMOJI} == -1 ) {
		# G폜
		&_remove_sjisemoji($param{STRING});
		&_remove_jemoji($param{STRING});
	} elsif ( $param{EMOJI} == 1 ) {
		# G10iR[h\Lɕϊ
		&_trans_sjisemoji2entity($param{STRING});
	}

	# SJIS  EUC-JPɕϊ
	jcode::sjis2euc($param{STRING});
}

#--------------------------------------------------------------------------
#	֐F	log2output
#	@\F	LOGt@Cۑ`̕\`ɕϊ܂B
#	F	STRING:	̃t@X
#			LINK:	I[gN邩ǂ
#				^l:	I[gN
#				Ul:	I[gNȂ(ftHg)
#			FORM:	tH[pɕϊ邩ǂ
#				^l:	tH[pɂ
#				Ul:	tH[pɂȂ(ftHg)
#			EMOJI:	G̈
#				-1:	G𖳌ɂ(10i\Lɕϊς݂Ƃ)
#				0:	Gɑ΂ĉȂ(ftHg)
#				1:	GoCiɖ߂
#--------------------------------------------------------------------------
sub log2output
{
	my %param = (
		STRING => \'',
		LINK => 0,
		FORM => 0,
		EMOJI => 0,
		@_,
		);

	if ( $param{FORM} ) {
		${$param{STRING}} =~ s/$NL/\n/g;
		${$param{STRING}} =~ s/"/&quot;/g;
	} else {
		&_space2nbsp($param{STRING});
		${$param{STRING}} =~ s#$NL#<br />#g;
		$param{LINK} and &_auto_link($param{STRING});
	}

	if ( $param{EMOJI} == -1 ) {
		&kill_emoji($param{STRING});
	}
	&jcode::euc2sjis($param{STRING});
	if ( $param{FORM} == 1 || $param{EMOJI} == 1 ) {
		&keep_sjisemoji_alive($param{STRING});
	}
}

#--------------------------------------------------------------------------
#	֐	set2output
#	@\	ݒ֘A̕o͗pɕϊ
#		STRING:	i[ϐ̃t@X
#			FORM:	tH[pɕϊ邩ǂ
#				^l:	tH[pɂ
#				Ul:	tH[pɂȂ(ftHg)
#--------------------------------------------------------------------------
sub set2output
{
	my %param = (
		STRING => \'',
		FORM => 0,
		@_,
		);

	my $str = ${$param{STRING}};
	&_enc_entity(\$str);
	$str =~ s/"/&quot;/g;
	$param{FORM} or $str =~ s#$NL#<br /> #g;
	return $str;
}

#--------------------------------------------------------------------------
#	֐	divide_string
#	@\	Log`̕𕪊
#		STRING:	i[ϐ̃t@X
#			LENGTH:	Pʒ
#			NUM:	؂ǒ(0w肷ƁAŌ܂ŕ)
#--------------------------------------------------------------------------
sub divide_string
{
	my %param = (
		STRING => \'',
		LENGTH => 24,
		NUM => 0,
		@_,
		);

	my @str;
	my $str = ${$param{STRING}};
	my $pre;
	my $cont = '...';

	length($str) < $param{LENGTH} and return [$str];
	$param{LENGTH} > ($cont * 2 + 1) and $param{LENGTH} -= length($cont);

	&_dec_entity(\$str, 'nl');
	while ( $str ne '' ) {
		$pre = substr($str, 0, $param{LENGTH});
		$str = substr($str, $param{LENGTH} );
		while ( $pre =~ /\x8F$/ || $pre =~ tr/\x8E\xA1-\xFE// % 2 ) {
			$str = chop($pre) . $str;
		}
		if ( $str ne '' ) {
			$pre .= $cont;
			$str = $cont . $str;
		}
		&_enc_entity(\$pre, 'nl');
		$pre ne '' and push(@str, $pre);
		@str == $param{NUM} and last;
	}

	return \@str;
}

#--------------------------------------------------------------------------
#	֐	send_mail
#	@\	sendmailȂǂgpă[𑗂
#		PATH:		sendmailȂǂ̃pX
#			FROM:		ol̃[AhX
#			TO:			̃[AhX
#			SUBJECT:	(JISR[h)
#			BODY:		{(JISR[h)
#--------------------------------------------------------------------------
sub send_mail
{
	my %param = (
		PATH => '',
		FROM => '',
		TO => '',
		SUBJECT => '',
		BODY => '',
		DEBUG => 0,
		@_,
		);

	my @mail;
	my $date = localtime() . ' +0900';

	push(@mail, qq(From: $param{FROM}$CRLF));
	push(@mail, qq(To: $param{TO}$CRLF));
	&_trans_mail_subj(\$param{SUBJECT});
	push(@mail, qq(Subject: $param{SUBJECT}$CRLF));
	push(@mail, qq(Date: $date$CRLF));
	push(@mail, qq(X-Mailer: CGIPON _PonCmn.pm ver.$VERSION$CRLF));
	push(@mail, qq(Content-Type: text/plain; charset="iso-2022-jp"$CRLF));
	push(@mail, qq($CRLF$param{BODY}$CRLF));

	if ( $param{DEBUG} ) {
		open (MAIL, ">mail.eml") or return;
	} else {
		open (MAIL, "| $param{PATH} -t") or return;
	}
	print MAIL join('', @mail);
	close (MAIL);
}

#--------------------------------------------------------------------------
#	֐	get_random_string
#	@\	_ȕ̎擾
#		NUM:	
#--------------------------------------------------------------------------
sub get_random_string
{
	my %param = (
		NUM => 8,
		@_,
		);

	my @chars = ("A".."Z", "a".."z", 0..9, qw(! " % ' + - * / = _));
	return join('', @chars[map { rand(@chars) } (1..$param{NUM})]);
}

#--------------------------------------------------------------------------
#	֐	url_enc
#	@\	URLGR[h
#		STRING:	i[ϐ̃t@X
#--------------------------------------------------------------------------
sub url_enc
{
	my %param = (
		STRING => \'',
		@_,
		);

	_url_enc($param{STRING});
}

#--------------------------------------------------------------------------
#	֐	url_dec
#	@\	URLGR[hꂽfR[h
#		STRING:	i[ϐ̃t@X
#--------------------------------------------------------------------------
sub url_dec
{
	my %param = (
		STRING => \'',
		@_,
		);

	_url_dec($param{STRING});
}


#--------------------------------------------------------------------------
#	֐	check_mail
#	@\	񂪃[AhXǂ̃`FbN(ł͂Ȃ)
#		STRING:	`FbNΏۂ̕
#--------------------------------------------------------------------------
sub check_mail
{
	my %param = (
		STRING => \'',
		@_
		);

	${$param{STRING}} =~ /[\w\.\-]+\@[\w\.\-]+/ or ${$param{STRING}} = '';
}


#--------------------------------------------------------------------------
#	֐	check_url
#	@\	URLǂ̃`FbN(ł͂Ȃ)
#		STRING:	`FbNΏۂ̕
#--------------------------------------------------------------------------
sub check_url
{
	my %param = (
		STRING => \'',
		@_
		);

	if ( ${$param{STRING}} =~ /http:\/\/[\w\+\?\.\/\-~&=:@%;,#]+/ ) {
		${$param{STRING}} =~ s#^http://##;
	} else {
		${$param{STRING}} = '';
	}
}


#==========================================================================
#	[ ֘ÃTu[` ]
#==========================================================================
#--------------------------------------------------------------------------
sub _space2nbsp
{
	my $s = shift;
	$$s =~ s/ /&nbsp;/g;
	$$s =~ s/(?:&nbsp;)([^(&nbsp;)])/ $1/g;
}

#--------------------------------------------------------------------------
sub _crlf2nl
{
	my $s = shift;
    $$s =~ s/\x0D\x0A/\n/g;
    $$s =~ tr/\r/\n/;
}

#--------------------------------------------------------------------------
sub _tab2space
{
	my $s = shift;
	$$s =~ s/\t/' ' x 4/eg;
}

#--------------------------------------------------------------------------
sub _trim_char
{
	my $s = shift;
	$$s =~ s/(\xA1\xA1| )+$//g;
	$$s =~ s/^(\xA1\xA1| )+//g;
}

#--------------------------------------------------------------------------
sub _trim_line
{
	my $s = shift;
	$$s =~ s/^\n+//g;
	$$s =~ s/(\n|| )+$//g;
	$$s =~ s/\n\n[\n]+/\n\n\n/g;
}

#--------------------------------------------------------------------------
sub _enc_entity
{
	my $s = shift;
	my %param;
	foreach ( @_ ) {
		$param{$_} = 1;
	}

	if ( ref($s) ) {
		$$s =~ s/&/&amp;/g;
		$$s =~ s/</&lt;/g;
		$$s =~ s/>/&gt;/g;
		$param{nl} and $$s =~ s/\n/$NL/g;
	} else {
		$s =~ s/&/&amp;/g;
		$s =~ s/</&lt;/g;
		$s =~ s/>/&gt;/g;
		$param{nl} and $s =~ s/\n/$NL/g;
		return $s;
	}
}

#--------------------------------------------------------------------------
sub _dec_entity
{
	my $s = shift;
	my %param;
	foreach ( @_ ) {
		$param{$_} = 1;
	}

	if ( ref($s) ) {
		$$s =~ s/&lt;/</g;
		$$s =~ s/&gt;/>/g;
		$param{nl} and $$s =~ s/$NL/\n/g;
		$$s =~ s/&amp;/&/g;
	} else {
		$s =~ s/&lt;/</g;
		$s =~ s/&gt;/>/g;
		$param{nl} and $s =~ s/$NL/\n/g;
		$s =~ s/&amp;/&/g;
		return $s;
	}
}

#--------------------------------------------------------------------------
sub _auto_link
{
	my $s = shift;
	$$s =~ s/(https?:\/\/[\w\+\?\.\/\-~&=:@%;,#]+)
		/<A href="$1" target="_blank">$1<\/A>/giox;
	$$s =~ s/(ftp:\/\/[\w\+\?\.\/\-~&=:@%;,]+)
		/<A href="$1" target="_blank">$1<\/A>/giox;
	$$s =~ s/([\w\.\-]+)\@([\w\.\-]+)
		/<A href="mailto\:$1\@$2">$1\@$2<\/A>/giox;
}

#--------------------------------------------------------------------------
sub _url_enc
{
	my $s = shift;
	$$s =~ s/(\W)/'%' . unpack('H2', $1)/eg;
	$$s =~ tr/ /+/;
}

#--------------------------------------------------------------------------
sub _url_dec
{
	my $s = shift;
	$$s =~ tr/+/ /;
	$$s =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack('H2', $1)/eg;
}

#--------------------------------------------------------------------------
sub _trans_iemoji2entity
{
	# Shift_JISŎg܂傤
	my $s = shift;
	$$s =~ /$IEMOJI_H/ or return;

	my $new;
	while ( $$s ne '' ) {
		if ( $$s =~ /^($IEMOJI)/ ) {
			$new .= '&#' . unpack('n', $1) . ';';
			$$s = substr($$s, length($1));
		} elsif ( $$s =~ /^($SJIS)/ ) {
			$new .= $1;
			$$s = substr($$s, length($1));
		}
	}
	$$s = $new;
}

#--------------------------------------------------------------------------
sub _trans_demoji2entity
{
	# Shift_JISŎg܂傤
	my $s = shift;
	$$s =~ /$DEMOJI_H/ or return;

	my $new;
	while ( $$s ne '' ) {
		if ( $$s =~ /^($DEMOJI)/ ) {
			$new .= '&#' . unpack('n', $1) . ';';
			$$s = substr($$s, length($1));
		} elsif ( $$s =~ /^($SJIS)/ ) {
			$new .= $1;
			$$s = substr($$s, length($1));
		}
	}
	$$s = $new;
}

#--------------------------------------------------------------------------
sub _trans_aemoji2entity
{
	# Shift_JISŎg܂傤
	my $s = shift;
	$$s =~ /$AEMOJI_H/ or return;

	my $new;
	while ( $$s ne '' ) {
		if ( $$s =~ /^($AEMOJI)/ ) {
			$new .= '&#' . unpack('n', $1) . ';';
			$$s = substr($$s, length($1));
		} elsif ( $$s =~ /^($SJIS)/ ) {
			$new .= $1;
			$$s = substr($$s, length($1));
		}
	}
	$$s = $new;
}

#--------------------------------------------------------------------------
sub _trans_sjisemoji2entity
{
	# Shift_JISŎg܂傤
	my $s = shift;

	$$s =~ /$SJISEMOJI_H/ or return;

	my $new;
	while ( $$s ne '' ) {
		if ( $$s =~ /^($SJISEMOJI)/ ) {
			$new .= '&#' . unpack('n', $1) . ';';
			$$s = substr($$s, length($1));
		} elsif ( $$s =~ /^($SJIS)/ ) {
			$new .= $1;
			$$s = substr($$s, length($1));
		}
	}
	$$s = $new;
}

#--------------------------------------------------------------------------
sub _remove_iemoji
{
	# Shift_JISŎg܂傤
	my $s = shift;

	my $new;
	while ( $$s ne '' ) {
		if ( $$s =~ /^($IEMOJI)/ ) {
			$$s = substr($$s, length($1));
		} elsif ( $$s =~ /^($SJIS)/ ) {
			$new .= $1;
			$$s = substr($$s, length($1));
		}
	}
	$$s = $new;
}

#--------------------------------------------------------------------------
sub _remove_demoji
{
	# Shift_JISŎg܂傤
	my $s = shift;

	my $new;
	while ( $$s ne '' ) {
		if ( $$s =~ /^($DEMOJI)/ ) {
			$$s = substr($$s, length($1));
		} elsif ( $$s =~ /^($SJIS)/ ) {
			$new .= $1;
			$$s = substr($$s, length($1));
		}
	}
	$$s = $new;
}

#--------------------------------------------------------------------------
sub _remove_sjisemoji
{
	# Shift_JISŎg܂傤
	my $s = shift;

	my $new;
	while ( $$s ne '' ) {
		if ( $$s =~ /^($SJISEMOJI)/ ) {
			$$s = substr($$s, length($1));
		} elsif ( $$s =~ /^($SJIS)/ ) {
			$new .= $1;
			$$s = substr($$s, length($1));
		}
	}
	$$s = $new;
}

#--------------------------------------------------------------------------
sub _remove_hemoji
{
	# Shift_JISŎg܂傤
	my $s = shift;
	$$s =~ s/\G($SJIS*)*?($HEMOJI)/$1/eg;
}

#--------------------------------------------------------------------------
sub _remove_jemoji
{
	# R[h͂Ȃłł
	my $s = shift;
	$$s =~ /$JEMOJI_ESC/ or return;
	$$s =~ s/$JEMOJI//g;
}

#--------------------------------------------------------------------------
sub kill_emoji
{
	my $s = shift;
	$$s =~ s/$JEMOJI//g;
	$$s =~ s/$HEMOJI//g;

	if ( $$s =~ /&#/ ) {
		$$s =~ s/&#$NUM_SJISEMOJI;//g;
	}
}

#--------------------------------------------------------------------------
sub keep_aemoji_alive
{
	my $s = shift;
	$$s =~ s/&#($NUM_AEMOJI);/ pack('n', $1) /eg;
}

#--------------------------------------------------------------------------
sub keep_demoji_alive
{
	my $s = shift;
	$$s =~ s/&#($NUM_DEMOJI);/ pack('n', $1) /eg;
}

#--------------------------------------------------------------------------
sub keep_iemoji_alive
{
	my $s = shift;
	$$s =~ s/&#($NUM_IEMOJI);/ pack('n', $1) /eg;
}

#--------------------------------------------------------------------------
sub keep_sjisemoji_alive
{
	my $s = shift;
	$$s =~ s/&#($NUM_SJISEMOJI);/ pack('n', $1) /eg;
}

#--------------------------------------------------------------------------
sub hemoji_or_kill
{
	my $s = shift;
	$$s =~ s/$JEMOJI//g;
	$$s =~ s/&lt;#(\[A-Z\!]+)&gt;/<#$1>/g;
	$$s =~ s/&#(?:$NUM_SJISEMOJI);//g;
}

#--------------------------------------------------------------------------
sub jemoji_or_kill
{
	my $s = shift;
	$$s =~ s{($JEMOJI_ESC)($JEMOJI_INT)($JEMOJI_SI)}
		{$1 . &_dec_entity($2) . $3}egx;
	$$s =~ s/&#(?:$NUM_SJISEMOJI);//g;
}

#--------------------------------------------------------------------------
sub _trans_mail_subj
{
	my $s = shift;
	$$s = '=?iso-2022-jp?B?' . &_enc_base64($$s) . '?=';
}

#--------------------------------------------------------------------------
sub _enc_base64
{
	my $base = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
		. "abcdefghijklmnopqrstuvwxyz"
		. "0123456789+/";
	my ($xx, $yy, $zz, $i);
	$xx = unpack("B*", $_[0]);
	for ($i = 0; $yy = substr($xx, $i, 6); $i += 6) {
		$zz .= substr($base, ord(pack("B*", "00" . $yy)), 1);
		if (length($yy) == 2) {
			$zz .= "==";
		} elsif (length($yy) == 4) {
			$zz .= "=";
		}
	}
	return $zz;
}

1;

__END__
